#include<iostream>
using namespace std;
void popuni(int zaliha[],int a[][4],int i,int j,int n)
{
    for(int k=0;k<n&&zaliha[i]!=0;k++)
    {
        while(a[k][i]==0)
            k++;
        if(a[k][i]<=-zaliha[i])
        {
            a[k][j]=a[k][i];
            a[k][i]=0;
            zaliha[i]+=a[k][j];
        }
        else
        {
            a[k][i]+=zaliha[i];
            a[k][j]-=zaliha[i];
            zaliha[i]=0;
        }
    }
}
int main()
{
    int n,i,j;
    cin>>n;
    int a[n][4];
    for(i=0;i<n;i++)
        for(j=0;j<4;j++)
            a[i][j]=0;
    int zaliha[4],kolicina[n];
    for(i=0;i<4;i++)
        cin>>zaliha[i];
    char krv[3];
    for(i=0;i<n;i++)
    {
        cin>>krv>>kolicina[i];
        if(krv[0]=='O')
            a[i][0]=kolicina[i];
        else if(krv[1]=='B')
            a[i][3]=kolicina[i];
        else if(krv[0]=='B')
            a[i][2]=kolicina[i];
        else
            a[i][1]=kolicina[i];

    }

    int k=0,zam,l=n;
    int potraznja[4];
    potraznja[0]=potraznja[1]=potraznja[2]=potraznja[3]=0;
    for(j=0;j<4;j++)
    {
        for(i=0;i<n;i++)
            potraznja[j]+=a[i][j];
    }
    zaliha[0]-=potraznja[0];
    zaliha[1]-=potraznja[1];
    zaliha[2]-=potraznja[2];
    zaliha[3]-=potraznja[3];

    if(zaliha[0]<0)
    {
        cout<<"nemoguce";
        return 0;
    }
    if(zaliha[1]<0)
    {
        zaliha[0]+=zaliha[1];
        popuni(zaliha,a,1,0,n);
        zaliha[1]=0;
    }
    if(zaliha[2]<0)
    {
        zaliha[0]+=zaliha[2];
        popuni(zaliha,a,2,0,n);
        zaliha[2]=0;
    }
    if(zaliha[3]<0)
    {
        for(int i=2;i>=1&&zaliha[3]!=0;i--)
        if(zaliha[i]>0)
        {
            if(zaliha[i]+zaliha[3]>=0)
            {
                zaliha[i]+=zaliha[3];
                popuni(zaliha,a,3,i,n);
                zaliha[3]=0;
            }
            else
            {
                l=zaliha[3];
                zaliha[3]=-zaliha[i];
                popuni(zaliha,a,3,i,n);
                zaliha[3]=l+zaliha[i];
                zaliha[i]=0;
            }
        }
        if(zaliha[3]!=0)
        {
            zaliha[0]+=zaliha[3];
            popuni(zaliha,a,3,0,n);
            zaliha[3]=0;
        }
    }

    if(zaliha[0]<0)
    {
        cout<<"nemoguce";
        return 0;
    }
    else
    {
        cout<<"moguce"<<endl;
        for(i=0;i<n;i++)
        {
            for(j=0;j<4;j++)
                cout<<a[i][j]<<" ";
            cout<<endl;
        }
    }
}